/*
  (c) 2005 Philipp Klaus Krause pkk@spth.de

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.
   
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
   
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#include <iostream>
#include <math.h>

int main(int argc, char **argv)
{
	const long double F = 3579000;
	long double base;

	char pitch;
	long double c;

	std::cout << "cvmtuning 0.2\n";
	std::cout << "This program will create tuning tables for the cvu library using equal tuning and a user-selectable pitch.\n";
	std::cout << "Select Pitch: I for ISO16 (A at 440 Hz), S for scientific (C at 256 Hz), A for custom specifying A, C for custom specifying C: ";
	std::cin >> pitch;
	if(pitch == 'I')
		c = 440 / powl(2.0l, 9.0l / 12.0l);
	else if(pitch == 'S')
		c = 256;
	else if(pitch == 'A')
	{
		std::cout << "Custom tuning selected! Please enter the frequency of A in Hz! ";
		std::cin >> c;
		c = c / pow(2.0l, 9.0l / 12.0l);
	}
	else
	{
		std::cout << "Custom tuning selected! Please enter the frequency of C in Hz! ";
		std::cin >> c;
	}
	base = c / 4.0l;
	for(long double i = 0; i < 12; i++)
	{
		std::cout << roundl(F / (base * powl(2.0l, i / 12.0l))) << ", ";
	}
	std::cout << "0, 0, 0";
	std::cout << '\n';
}
